/*
 * SQL Connector Utility Methods
 */

// Create a new SQLStatement instance
function newSQLStatement(sql) {
    var statement = new tw.object.SQLStatement();
    statement.sql = sql;
    return statement;
}
 
// Create a new SQLParameter instance
function newSQLParameter(value, type, mode) {
    var parameter = new tw.object.SQLParameter();
    parameter.value = value;
    parameter.type = type;
    parameter.mode = mode;
    return parameter;
}

// Create and add a SQLParameter to a SQLStatement, 
// creating the list for the statement's parameters
// property if necessary
function addSQLParameter(statement, value, type, mode) {
    if (!statement.parameters) {
        statement.parameters = new tw.object.listOf.SQLParameter();
    }
    var parameter = newSQLParameter(value, type, mode);
    statement.parameters[statement.parameters.listLength] = parameter;
    return parameter;
}

// Add an IN SQLParameter to the SQLStatement
function addInSQLParameter(statement, value, type) {
    return addSQLParameter(statement, value, type, "IN");
}

// Add an OUT SQLParameter to the SQLStatement
function addOutSQLParameter(statement, type) {
    return addSQLParameter(statement, null, type, "OUT");
}

// Add an INOUT SQLParameter to the SQLStatement
function addInOutSQLParameter(statement, value, type) {
    return addSQLParameter(statement, value, type, "INOUT");
}
