function getJavaClass(object) {
   return Packages.com.lombardisoftware.core.script.js.JSHelper.getJavaClass(object);
}

function assertEquals(message, expected, actual) {
   if (expected == null && actual == null) {
      return;
   }

   if (expected == actual) {
      return;
   }

  throw message + ". Expected: \"" + expected + "\", but it was \""  + actual + "\".";
}

function assertNotEquals(message, expected, actual) {
  if (expected == null && actual == null) {
    return;
  }

  if (expected == actual) {
    throw message + ". Expected: \"" + expected + "\", but it was \""  + actual + "\".";
  }

  if (expected == null || actual == null) {
    return;
  }
}


function assertGreater(message, limit, actual) {
   if (limit == null && actual == null) {
      return;
   }

   if (actual > limit) {
      return;
   }

   throw message + ". Actual \"" + actual + "\" was not greater than \""  + limit + "\".";
}

function assertExists(message, variable) {
    if (variable == null)
        throw message + ". Does not exist.";

    return;
}

function assertNotExists(message, variable) {
    if (variable != null)
        throw message + ". Does exist.";

    return;
}

function assertTrue(message, bool) {
   if (!bool) {
      throw "assertTrue() failed. " + message;
   }
}

function assertFalse(message, bool) {
   if (bool) {
      throw "assertFalse() failed. " + message;
   }
}
function dbType(jndiName) {
    var context = new Packages.javax.naming.InitialContext();
    var dataSource = context.lookup(jndiName);
    var connection = dataSource.getConnection();
    var metaData = connection.getMetaData();
    var db = new String(metaData.getDatabaseProductName());
    if (! isInGlobalTransaction()) {
        try {
            // You MUST have this commit() here otherwise under WebSphere
            // you will start a Local Transaction
            connection.commit();
        } catch (e) {}
    }
    connection.close();

    return db;
}


function isInGlobalTransaction() {
    var isInGlobalTxn = false;
    try {
        var context = new Packages.javax.naming.InitialContext();
        var uowSync = context.lookup("java:comp/websphere/UOWSynchronizationRegistry");
        isInGlobalTxn = (uowSync.getUOWType() == uowSync.UOW_TYPE_GLOBAL_TRANSACTION);
    } catch (ignoreit) {
        if (log.debugEnabled) log.debug("Exception while determining whether run in global transaction : " + ignoreit.toString());
    }
    if (log.debugEnabled) log.debug("isInGlobalTransaction : " + isInGlobalTxn);
    return isInGlobalTxn;
}

// WebSphere: need to use resource references
var main_db_dbType = dbType("jdbc/TeamWorksDB");

function __oracle_dateStringToDB(datestr) {
    return "to_date('" + datestr + "', 'MM/dd/yyyy hh24:mi:ss')";
}

function __mssql_dateStringToDB(datestr) {
    var dt = new TWDate();
    dt.parse(datestr, "MMM/dd/yyyy HH:mm:ss");
    return "'" + dt.format("dd/MMM/yyyy HH:mm:ss") + "'";
}

function dateStringToDB(datestr) {
   if (main_db_dbType == "Oracle")
       return __oracle_dateStringToDB(datestr);

   if (main_db_dbType == "Microsoft SQL Server")
       return __mssql_dateStringToDB(datestr);
}

function calculateDateRange(dateRange) {
  var range = dateRange.split(" ")[0];
  var resolution = dateRange.split(" ")[1].substr(0,2).toLowerCase(); // Mi(nute), Ho(ur), Da(ys)

  if (range.indexOf("-") > 0) {
     // A Range not starting with baseTime
     var ranges = range.split("-");
     tmpstartTime = Number(ranges[0]);
     tmpendTime = Number(ranges[1]);
  } else if (range.indexOf("+") > 0) {
     // Range but starting at the number.. endTime set to very very big number
     var ranges = range.split("+");
     tmpstartTime = Number(ranges[0]);
     tmpendTime = Number(9999999);
  } else {
     tmpstartTime = 0;
     tmpendTime = Number(range);
  }

  if (resolution == "mi") {
     tmpstartTime = tmpstartTime * 60;
     tmpendTime = tmpendTime * 60;
  } else if ((resolution == "ho") || (resolution == "hr")) {
     tmpstartTime = tmpstartTime * 3600;
     tmpendTime = tmpendTime * 3600;
  } else if ((resolution == "da") || (resolution == "dy")) {
     tmpstartTime = tmpstartTime * 24 * 3600;
     tmpendTime = tmpendTime * 24 * 3600;
  } else {
     throw "DateRange '" + dateRange + "' does not have a valid time resolution (" + resolution + "). Please fix your dateRange parameter";
  }

  var ret = new Object();
  ret.start = tmpstartTime;
  ret.end = tmpendTime;

  return ret;
}

function calculateDateFromPeriodAndResolution(period, resolution) {
  var date = new TWDate();

  if (resolution == "hour") {
     date.parse(period, "MM/dd HH:mm");
  } else if (resolution == "day") {
     date.parse(period, "MM/dd");
  } else if (resolution == "week") {
     date.parse(period, "ww/yy");
  } else if (resolution == "month") {
     date.setDate(1);
     date.parse(period, "MM/yy");
  } else if (resolution == "quarter") {
     date.setDate(1);
     date.parse(period, "MM/yy");
  } else if (resolution == "year") {
     date.setMonth(0);
     date.setDate(1);
     date.parse(period, "yyyy");
  }

  // date.setDate(date.getDate() + 1);

  return date;
}

function calculateTimeMod(timeMod) {
  var value = timeMod;
  var tp = timeMod.substring(0,4);
  if ((tp == "last") || (tp == "this") || (tp == "next")) {
    var timeMod = value.substring(4,5).toLowerCase();
    var dt = new TWDate();
    dt.setSeconds(0);
    dt.setMinutes(0);
    if (timeMod == "h") {
        if (tp == "last") dt.setHours(dt.getHours() - 1);
        if (tp == "next") dt.setHours(dt.getHours() + 1);

    } else {
        dt.setHours(1);
        if (timeMod == "d") {
          if (tp == "last") dt.setDate(dt.getDate() - 1);
          if (tp == "next") dt.setDate(dt.getDate() + 1);
        } else {
          if (timeMod == "w") {
            dt.setDate(dt.getDate() - dt.getDay() + 1);
            if (tp == "last") dt.setDate(dt.getDate() - 7);
            if (tp == "next") dt.setDate(dt.getDate() + 7);
          } else {
            dt.setDate(1);
            if (timeMod == "m") {
              if (tp == "last") dt.setMonth(dt.getMonth() - 1);
              if (tp == "next") dt.setMonth(dt.getMonth() + 1);
            } else if (timeMod == "q") {
              dt.setMonth(Math.floor(dt.getMonth() / 3) * 3);
              if (tp == "last") dt.setMonth(dt.getMonth() - 3);
              if (tp == "next") dt.setMonth(dt.getMonth() + 3);
            } else if (timeMod == "y") {
              dt.setMonth(0);
              if (tp == "last") dt.setYear(dt.getYear() - 1);
              if (tp == "next") dt.setYear(dt.getYear() + 1);
            }
          }
      }
    }
    value = dt.format("MMM/dd/yyyy HH:mm:ss");
  }
  return value;
}
function __initArray() {
    this.length = __initArray.arguments.length;
    for (var i = 0; i < this.length; i++)
        this[i] = __initArray.arguments[i];
}

function from10toradix(value,radix){
    var retval = '';
    var ConvArray = new __initArray(0,1,2,3,4,5,6,7,8,9,'A','B','C','D','E','F');
    var intnum;
    var tmpnum;
    var i = 0;

    intnum = parseInt(value,10);
    if (isNaN(intnum)){
        retval = 'NaN';
    }else{
        while (intnum > 0.9){
            i++;
            tmpnum = intnum;
            // cancatinate return string with new digit:
            retval = ConvArray[tmpnum % radix] + retval;
            intnum = Math.floor(tmpnum / radix);
            if (i > 100){
                // break infinite loops
                retval = 'NaN';
                break;
            }
        }
    }
    return retval;
}

function getTaskStatusStringFromStatus(statusId) {
  if (statusId == "11")
    return "New";
  if (statusId == "12")
    return "Received";
  if (statusId == "13")
    return "Replied";
  if (statusId == "14")
    return "Forwarded";
  if (statusId == "21")
    return "Sent";
  if (statusId == "31")
    return "Actioned";
  if (statusId == "32")
    return "Closed";
  if (statusId == "41")
    return "Special";
  if (statusId == "91")
    return "Deleted";
  if (statusId == "92")
    return "Deleted";

  return "Custom";
}

// This Method is Deprecated.
function getBpdIdFromName(name) {
    throw new Error("Not Supported");
}

// Below is an example of calling this JS function:
//
// var map = new tw.object.Map();
// map.put("param1", "param1 value is a string");
// map.put("xmldoc", new TWDDocument("<root><name>My Name</name></root>"));
// var id = startBpdWithName("theBpd", map);
//
function startBpdWithName(name, inputValues) {
    if(inputValues == undefined ) {
        inputValues = new tw.object.Map();
    }
    var instance = tw.system.startProcessByName(name, inputValues);
    return tw.system.convertIDToDB(instance.id);
}

// id (java.math.BigDecimal): the ID of the BPD to start
// inputValues (tw.object.Map): a map of values to pass to the BPD
// return (String): the BPD instance ID as a string
function startBpdWithId(id, inputValues) {
    throw new Error("Not Supported");
}

// This function allows you to clear the WSDL cache that TeamWorks and Axis keeps for
// Web Services to enhance performance. You need to do this if the WSDL changes for a Web
// Service and you do not want to bounce your server
function clearWSDLCache() {

    Packages.org.apache.axis.client.Service.clearAllCacheWSDL();
    Packages.com.lombardisoftware.client.persistence.ConnectorDefFactory.getInstance().clearAllCache();
}

// Get time stamp wtih time zone offset.
function getTimeWithTimezoneOffset(date) {
    return date.getTime() + date.getTimezoneOffset() * 1000 * 60;
}

// Calculate range in milliseconds for the given day. Start and end bounds are Y2K based.
// date (Date): a date for which a day range will be calculated
// return (Object): start property indicates begining of the day in milliseconds starting
//                  from 1/1/2000 00:00:00, end property - end of the day.
function calculateDayRangeY2K(date) {
    var dateUTC = getTimeWithTimezoneOffset(date);
    var y2kUTC = getTimeWithTimezoneOffset(new Date("1/1/2000 00:00:00"));
    
    var result = new Object();
    result.start = dateUTC - y2kUTC;
    result.end = dateUTC - y2kUTC + (1000*60*60*24);
    
    return result;
}
