//
// Function: readFile( fileName)
//
// Returns the file content as a string. Will return an exception if 
// the file does not exist.
//
// Note   : Careful about using this function in clustered production 
//          environments. The file must then exist on all clustered
//          application servers in the same spot!
//
// Author : Morten Moeller (mmoeller@lombardisoftware.com)
//
function readFile(fileName) {

    var rd = new java.io.BufferedReader(new java.io.FileReader(fileName));
    var file = "";

    while ((l = rd.readLine()) != null) 
        file += l + "\n";

    rd.close();

    return file;
}

//
// Function: deleteFile( fileName)
//
// Deletes the file from the local filesystem. Will return an exception if
// the file does not exist.
//
function deleteFile(fileName) {

    var theFile = new java.io.File(fileName);
    theFile["delete"]();
}
