/*
 * This file is required for reporting. It handles pre and post calculations for chart datasource calls
 */

function bindDataSourcesToChart() {

    if (log.debugEnabled)
        log.debug("Bottom labels to chart is : " + reportLabels.toXMLString());

    var labelLength = reportLabels.arrayLength;
    var seriesNames = new TWObject();

    if (labelLength > 0) {
        chart.addBottomLabels(reportLabels);
    }

    // Add all series
    for (var i = 0 ; i < reportSeries.arrayLength ; i++) {
        var currentSeries = reportSeries[i];

        if ((labelLength > 0) && (currentSeries.arrayLength < labelLength))
            currentSeries[reportLabels.arrayLength-1] = null;

        var currentName = currentSeries.name;
        if (seriesNames[currentName] != null) {
            var c = seriesNames[currentName];
            seriesNames[currentName]++;
            currentName = currentName + "(" + c + ")";
        } else {
            seriesNames[currentName] = 1;
        }

        if (log.debugEnabled)
            log.debug("Adding series --> " + currentSeries.toXMLString());
        chart.addSerie(chart.seriesCount, currentName, currentSeries.type, reportSeries[i]);
    }
}

function findSeries(seriesName) {
     // Find series object
    var key = settings.datasourceName + "," + seriesName;
    var currentSeriesId = reportSeries[key];
    var currentSeries;

    if (currentSeriesId == null) {
        // Create a new series
        currentSeries = new TWObject();
        currentSeries.key = key;
        currentSeries.name = seriesName;
        currentSeries.type = settings.serieType;

        reportSeries[key] = reportSeries.arrayLength;
        reportSeries[reportSeries.arrayLength] = currentSeries;
    } else {
        currentSeries = reportSeries[currentSeriesId];
    }

    return currentSeries;
}

function findLabelId(labelName) {
    var labelId = reportLabels["z" + labelName]; // Force string version to ensure this is used as a map

    if (labelId == null) {
        labelId = reportLabels.arrayLength;
        reportLabels["z" + labelName] = labelId;
        reportLabels[labelId] = labelName;
    }

    return labelId;
}

function addDataToSeries(seriesName, labelId, data) {
    var currentSeries = findSeries(seriesName);
    currentSeries[labelId] = data;
}
