function list_get_pos(p_list, p_delim, p_position)
{
	var v_list_length, v_delim_length;
	var v_counter, v_pos;
	var V_pre_delims;
	var v_pre_pos, v_post_pos;


	//empty list, nothing to find
	if (p_list == null) {return("");}

	//null delimiter, cant get a position
	if (p_delim == null) {return("");}

	//invalid position, nothing to find
	if (p_position <= 0 && p_position != -1) {return("");}

	v_list_length  = p_list.length;
	v_delim_length = p_delim.length;

	//number of checks for delim's in the list
	v_counter      = v_list_length - v_delim_length + 1;

	//number of delim's to find the start and end position of the item
	v_pre_delims = p_position;

	v_pos        = 0;
	v_pre_pos    = 0;
	v_post_pos   = 0;


	//get the last item on the list
	if (p_position==-1)
	{
		//search for p_delim's
		while (v_counter-->0)
		{
			//is the current poition the delim?
			if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
			{
				v_pos = v_pos + v_delim_length -1;	//skip rest of found delim
				v_counter = v_counter - v_delim_length + 1;
				v_pre_pos = v_pos;			//mark beginning of next item
			}
		}
		//return last item
		//if the last item is null, this will return null
		return(p_list.substring(v_pre_pos, v_list_length + 1));
	}
	else
	{
		//search for p_delim's
		while (v_pre_delims>0 && v_counter-->0)
		{
			//is the current position the delim?
			if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
			{
				v_pre_delims--;					//delim found

				//mark start of this item
				v_pre_pos  = v_post_pos + v_delim_length + 1;
				//mark end of this item
				v_post_pos = v_pos - 2;

				//skip rest of this item
				v_pos = v_pos + v_delim_length -1;
				v_counter = v_counter - v_delim_length + 1;
			}
		}

		//want to get the last item in the list
		if (v_pre_delims==1)
		{
			return(p_list.substring(v_post_pos + v_delim_length + 1, v_list_length + 1));
		}
		else
		{
			//want to get an item at a position greater than the current 
			//number of items in the list. Return nothing.
			if (v_pre_delims!=0)
			{
				return("");
			}
			else
			{
				//first item in the list?
				if (p_position==1) {v_pre_pos=0;}
				//return item.
				return(p_list.substring(v_pre_pos, v_post_pos + 1));
			}
		}
	}
}














function list_put_pos(p_list, p_delim, p_position, p_item)
{
	var v_pre_list, v_post_list;
	var v_list_length, v_delim_length;
	var v_counter, v_pos;
	var V_pre_delims, v_post_delims;
	var v_pre_pos, v_post_pos;


	if (p_list == null) {p_list="";}

	if (p_item == null) {p_item="";}

	//invalid position, list remains unchanged
	if (p_position <= 0 && p_position != -1) {return(p_list);}


	// We build a PreList and a PostList and use these to build the new list (PreList+Item+PostList)

	//add the item to the end of the list
	if (p_position==-1)
	{
		v_pre_list   = p_list + p_delim;
		v_post_list  = "";
	}
	else
	{
		v_list_length  = p_list.length;
		v_delim_length = p_delim.length;

		//number of checks required for delim's in the list
		v_counter      = v_list_length - v_delim_length + 1;

		//Number of delim's before the item position
		v_pre_delims = p_position - 1;

		v_pos        = 0;
		v_pre_pos    = 0;
		v_post_pos   = 0;

		//search for p_delim's
		while (v_pre_delims>0 && v_counter-->0)
		{
			// is the current position the delim?
			if (p_list.substring(v_pos, v_pos++ + v_delim_length) == p_delim)
			{
				v_pre_delims--;			    //delim found
				v_pos = v_pos + v_delim_length -1;  //skip rest of found delim
				v_counter = v_counter - v_delim_length + 1;
			}
		}

		//want to place the item at a position greater than the current 
		//number of item in the list. Insert the required bank items.
		if (v_pre_delims!=0)
		{
			v_pre_list = p_list;
			while (v_pre_delims-->0)
			{
				v_pre_list = v_pre_list + p_delim;
			}
			v_post_list = "";
		}
		else
		{
			//end position of the pre-list
			v_pre_pos    = v_pos - v_delim_length - 1;

			//find the end of the item to replace
			v_post_delims = 1;
			while (v_post_delims>0 && v_counter-->0)
			{
				//is the current position the delim?
				if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
				{
					v_post_delims--;
				}
			}
			//start position of post list
			v_post_pos    = v_pos + v_delim_length - 1;


			//build pre-list
			v_pre_list   = p_list.substring(0,v_pre_pos + 1);
			//if we are not adding the item to the front (the PreList isnt null),
			//add  a delim at the end of the PreLilst.
			if (p_position!=1) {v_pre_list = v_pre_list + p_delim;}


			//build post-list
			v_post_list  = p_list.substring(v_post_pos,p_list.length);
			//if we are not adding the item to the end (the PostList isnt null),
			//add a delim at the front of the PostList.
			if (v_post_delims==0) {v_post_list = p_delim + v_post_list;}
		}
	}

	//build list
	p_list = v_pre_list + p_item + v_post_list;
	return(p_list);
}















function list_del_pos(p_list, p_delim, p_position)
{
	var v_pre_list, v_post_list;
	var v_list_length, v_delim_length;
	var v_counter, v_pos;
	var v_pre_delims, v_post_delims;
	var v_pre_pos, v_post_pos;


	//list is empty, nothing to delete
	if (p_list == null) {return("");}

	//invalid position, list remains unchanged
	if (p_position <= 0 && p_position != -1) {return(p_list);}

	v_list_length  = p_list.length;
	v_delim_length = p_delim.length;

	//number of checks for delim's in the list
	v_counter      = v_list_length - v_delim_length + 1;

	v_pos        = 0;
	v_pre_pos    = 0;
	v_post_pos   = 0;


	//delete the item from the end of the list
	if (p_position==-1)
	{
		//search for p_delim's
		while (v_counter-->0)
		{
			//is the current poition the delim?
			if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
			{
				v_pos = v_pos + v_delim_length -1;	//skip rest of found delim
				v_counter = v_counter - v_delim_length + 1;
				v_pre_pos = v_pos - v_delim_length;	//mark delim after last item
			}
		}
		//return list without last item
		return(p_list.substring(0, v_pre_pos));
	}
	else
	{
		//Number of delim's before the item position
		v_pre_delims = p_position - 1;

		//search for p_delim's
		while (v_pre_delims>0 && v_counter-->0)
		{
			// is the current position the delim?
			if (p_list.substring(v_pos, v_pos++ + v_delim_length) == p_delim)
			{
				v_pre_delims--;			    //delim found
				v_pos = v_pos + v_delim_length -1;  //skip rest of found delim
				v_counter = v_counter - v_delim_length + 1;
			}
		}

		//want to delete an item at a position greater than the current 
		//number of item in the list. Original list returned unchanged.
		if (v_pre_delims!=0)
		{
			return(p_list);
		}
		else
		{
			//end position of the pre-list
			v_pre_pos    = v_pos - v_delim_length - 1;

			//find the end of the item to replace
			v_post_delims = 1;
			while (v_post_delims>0 && v_counter-->0)
			{
				//is the current position the delim?
				if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
				{
					v_post_delims--;	//delim found
				}
			}
			//start position of post list
			v_post_pos    = v_pos + v_delim_length - 1;

			//build pre-list
			v_pre_list   = p_list.substring(0,v_pre_pos + 1);

			//build post-list
			v_post_list  = p_list.substring(v_post_pos,p_list.length);

			//build list
			if (p_position==1 || v_post_delims!=0)
			{
				p_list = v_pre_list + v_post_list;
			}
			else
			{
				p_list = v_pre_list + p_delim + v_post_list;
			}
			return(p_list);
		}
	}

}















function list_get_id(p_list, p_delim, p_id)
{
	var v_list_length, v_delim_length;
	var v_counter, v_pos;
	var v_pre_pos, v_post_pos;
	var v_item, v_item_length;
	var v_item_counter, v_item_pos;


	//empty list, nothing to find
	if (p_list == null) {return("");}

	//null delimiter, cant get a position
	if (p_delim == null) {return("");}

	v_list_length  = p_list.length;
	v_delim_length = p_delim.length;

	//number of checks for delim's in the list
	v_counter      = v_list_length - v_delim_length + 1;

	v_pos        = 0;
	v_pre_pos    = 0;
	v_post_pos   = 0;

	//search for items
	while (v_counter-->0)
	{
		//is the current position delim?
		if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
		{
			//mark the end of this item
			v_post_pos = v_pos - 2;

			//get this item
			v_item = p_list.substring(v_pre_pos, v_post_pos + 1);

			//mark the start of the next item
			v_pre_pos = v_post_pos + v_delim_length + 1

			//check item
			v_item_length = v_item.length;
			v_item_counter = v_item_length;
			v_item_pos = 0;

			while (v_item_counter-->0)
			{
				//is the current position '='?
				if (v_item.substring(v_item_pos, v_item_pos++ + 1)=="=")
				{
					//is this the item we want??
					if (v_item.substring(0, v_item_pos-1)==p_id)
					{
						//return the item value
						return(v_item.substring(v_item_pos, v_item_length))
					}
					else
					{
						//try the next item
						v_item_counter=0;
					}
				}
			}
		}
	}
	//the last item in the list
	v_item = p_list.substring(v_pre_pos, v_list_length);

	v_item_length = v_item.length;
	v_item_counter = v_item_length;
	v_item_pos = 0;
	while (v_item_counter-->0)
	{
		//is the current position '='?
		if (v_item.substring(v_item_pos, v_item_pos++ + 1)=="=")
		{
			//is this the item we want??
			if (v_item.substring(0, v_item_pos-1)==p_id)
			{
				//return the item value
				return(v_item.substring(v_item_pos, v_item_length))
			}
			else
			{
				//its not the last item!
				v_item_counter=0;
			}
		}
	}
	//its not in the list!!
	return("");
}















function list_put_id(p_list, p_delim, p_id, p_item)
{
	var v_list_length, v_delim_length;
	var v_counter, v_pos;
	var v_pre_pos, v_post_pos;
	var v_item, v_item_length;
	var v_item_counter, v_item_pos;
	var v_pre_list, v_post_list;
	var v_item_start;


	//null delimiter, cant get a position
	if (p_delim == null) {return(p_list);}

	//empty list, return single new item
	if (p_list == null) {return(p_id + "=" + p_item);}

	v_list_length  = p_list.length;
	v_delim_length = p_delim.length;

	//number of checks for delim's in the list
	v_counter      = v_list_length - v_delim_length + 1;

	v_pos        = 0;
	v_pre_pos    = 0;
	v_post_pos   = 0;

	//search for items
	while (v_counter-->0)
	{
		//is the current position delim?
		if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
		{
			//mark the end of this item
			v_post_pos = v_pos - 2;

			//get this item
			v_item = p_list.substring(v_pre_pos, v_post_pos + 1);

			//mark start of current item
			v_item_start = v_pre_pos;
			//mark the start of the next item
			v_pre_pos = v_pos + v_delim_length - 1;

			//check item
			v_item_length = v_item.length;
			v_item_counter = v_item_length;
			v_item_pos = 0;

			//is this the correct item?
			while (v_item_counter-->0)
			{
				//is the current position '='?
				if (v_item.substring(v_item_pos, v_item_pos++ + 1)=="=")
				{
					//is this the item we want??
					if (v_item.substring(0, v_item_pos-1)==p_id)
					{
						//not the first item in the list
						if (v_item_start!=0)
						{
							v_pre_list= p_list.substring(0, v_item_start);
							v_post_list = p_list.substring(v_pre_pos - v_delim_length, v_list_length);
						}
						else
						{
							v_pre_list = "";
							v_post_list = p_list.substring(v_pre_pos - v_delim_length,v_list_length);
						}
						p_list = v_pre_list + p_id + "=" + p_item + v_post_list;
						return(p_list);
					}
					else
					{
						//try the next item
						v_item_counter=0;
					}
				}
			}
		}
	}
	//check the last item in the list
	v_item = p_list.substring(v_pre_pos, v_list_length);

	v_item_length = v_item.length;
	v_item_counter = v_item_length;
	v_item_pos = 0;

	//is this the correct item?
	while (v_item_counter-->0)
	{
		//is the current position '='?
		if (v_item.substring(v_item_pos, v_item_pos++ + 1)=="=")
		{
			//is this the item we want??
			if (v_item.substring(0, v_item_pos-1)==p_id)
			{
				v_item_counter=0;
				v_pre_list= p_list.substring(0, v_pre_pos);
				v_post_list = "";
				p_list = v_pre_list + p_id + "=" + p_item + v_post_list;
				return(p_list);
			}
		}
	}

	//item not found in the list
	v_pre_list = p_list;
	v_post_list = "";

	//add delimiter if PreList isnt null
	if (v_item_start!=0)
	{
		v_pre_list = v_pre_list + p_delim;
	}

	//add delimiter if PostList isnt null
	if (v_post_list!="")
	{
		v_post_list = p_delim + v_post_list;
	}

	p_list = v_pre_list + p_id + "=" + p_item + v_post_list;
	return(p_list);
}















function list_del_id(p_list, p_delim, p_id)
{
	var v_list_length, v_delim_length;
	var v_counter, v_pos;
	var v_pre_pos, v_post_pos;
	var v_item, v_item_length;
	var v_item_start;
	var v_item_counter, v_item_pos;
	var v_pre_list, v_post_list;



	//null delimiter, cant get a position
	if (p_delim == null) {return(p_list);}

	//empty list, nothing to delete
	if (p_list == null) return("");

	v_list_length  = p_list.length;
	v_delim_length = p_delim.length;

	//number of checks for delim's in the list
	v_counter      = v_list_length - v_delim_length + 1;

	v_pos        = 0;
	v_pre_pos    = 0;
	v_post_pos   = 0;

	//search for items
	while (v_counter-->0)
	{
		//is the current position delim?
		if (p_list.substring(v_pos, v_pos++ + v_delim_length)==p_delim)
		{
			//mark the end of this item
			v_post_pos = v_pos - 2;

			//get this item
			v_item = p_list.substring(v_pre_pos, v_post_pos + 1);

			//mark start of current item
			v_item_start = v_pre_pos;
			//mark the start of the next item
			v_pre_pos = v_pos + v_delim_length - 1;

			//check item
			v_item_length = v_item.length;
			v_item_counter = v_item_length;
			v_item_pos = 0;

			//is this the correct item?
			while (v_item_counter-->0)
			{
				//is the current position '='?
				if (v_item.substring(v_item_pos, v_item_pos++ + 1)=="=")
				{
					//is this the item we want??
					if (v_item.substring(0, v_item_pos-1)==p_id)
					{
						//not the first item in the list
						if (v_item_start!=0)
						{
							v_pre_list= p_list.substring(0, v_item_start);
							v_post_list = p_list.substring(v_pre_pos, v_list_length);
						}
						else
						{
							v_pre_list = "";
							v_post_list = p_list.substring(v_pre_pos, v_list_length);
						}
						p_list = v_pre_list + v_post_list;
						return(p_list);
					}
					else
					{
						//try the next item
						v_item_counter=0;
					}
				}
			}
		}
	}
	//check the last item in the list
	v_item = p_list.substring(v_pre_pos, v_list_length);

	v_item_length = v_item.length;
	v_item_counter = v_item_length;
	v_item_pos = 0;

	//is this the correct item?
	while (v_item_counter-->0)
	{
		//is the current position '='?
		if (v_item.substring(v_item_pos, v_item_pos++ + 1)=="=")
		{
			//is this the item we want??
			if (v_item.substring(0, v_item_pos-1)==p_id)
			{
				return(p_list.substring(0, v_pre_pos - v_delim_length));
			}
		}
	}

	//item not found in the list
	return(p_list);
}
