<?xml version="1.0"?>

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    exclude-result-prefixes="java">

    <xsl:output method="xml" indent="yes"/>

    <xsl:template match="/teamworks">
        <teamworks version="BamBam">
            <xsl:apply-templates/>
        </teamworks>
    </xsl:template>

    <xsl:template match="/teamworks/process">
        <process id="{@id}" name="{@name}">
            <tabGroup isNull="true" />
            <xsl:apply-templates />
        </process>
    </xsl:template>

    <xsl:template match="/teamworks/process/item">
        <item>
            <correlationPointDfnId isNull="true"/>
            <xsl:apply-templates />
        </item>
    </xsl:template>

    <xsl:template match="/teamworks/layout/layoutParam">
        <layoutParam name="{@name}">
            <xsl:apply-templates/>
            <seq isNull="true"/>
        </layoutParam>
    </xsl:template>

	<xsl:template match="/teamworks/underCoverAgent">
	    <underCoverAgent id="{@id}" name="{@name}">
	        <xsl:apply-templates />
	        <isEnabled>true</isEnabled>
	    </underCoverAgent>
	</xsl:template>
	
	    <!-- This is the identity template -->
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>