<?xml version="1.0"?>

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    exclude-result-prefixes="java">

    <xsl:output method="xml" indent="yes"/>

    <xsl:template match="/teamworks">
        <teamworks buildId="TeamWorks Library Format V60">
            <xsl:apply-templates/>
        </teamworks>
    </xsl:template>

    <xsl:template match="/teamworks/bpd">
        <bpd id="{@id}" name="{@name}">
            <xsl:apply-templates/>
            <isSpcEnabled>false</isSpcEnabled>
        </bpd>
    </xsl:template>

    <xsl:template match="/teamworks/participant">
        <participant id="{@id}" name="{@name}">
            <xsl:apply-templates/>
            <capacityType isNull="true" />
            <definitionType>1</definitionType>
            <percentAvailable isNull="true" />
            <percentEfficiency isNull="true" />
            <image isNull="true" />
        </participant>
    </xsl:template>

	<xsl:template match="sendToType">
		<sendToType>
		<xsl:choose>
			<xsl:when test="text() = 2">3</xsl:when>
			<xsl:otherwise><xsl:value-of select="text()" /></xsl:otherwise>
		</xsl:choose>
		</sendToType>
	</xsl:template>

    <!-- This is the identity template -->
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>