<?xml version="1.0"?>

<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    exclude-result-prefixes="java">

    <xsl:output method="xml" indent="yes"/>

    <xsl:template match="/teamworks">
        <teamworks buildId="TeamWorks Library Format V71">
            <xsl:apply-templates/>
        </teamworks>
    </xsl:template>

    <xsl:template match="/teamworks/connector/definition/connector[@type = 'teamworks.connector.SOAPConnector']/config/endpointAddress">
        <endpointAddress>
            <xsl:choose>
                <xsl:when test="@overrideEndpointAddress = 'false'">
                    <xsl:attribute name="overrideEndpointAddress">false</xsl:attribute>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:choose>
                        <xsl:when test="string-length(text()) = 0"><xsl:attribute name="overrideEndpointAddress">false</xsl:attribute></xsl:when>
                        <xsl:otherwise><xsl:attribute name="overrideEndpointAddress">true</xsl:attribute></xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:apply-templates/>
        </endpointAddress>
    </xsl:template>

    <!-- This is the identity template -->
    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>