<?xml version="1.0"?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<!-- A number of common templates that are used when transforming result sets -->

<!-- This must be called in the context of a column in the first record -->
<!-- in the result set. It inserts the title for a column, choosing first -->
<!-- the value of the title attribute, and if that is not present defaulting -->
<!-- to the value of the name attribute, which is the name used for the column -->
<!-- in the select that produced the result set. -->
<xsl:template name="columnTitle">
  <xsl:choose>
    <xsl:when test="@title"><xsl:value-of select="@title"/></xsl:when>
    <xsl:otherwise><xsl:value-of select="@name"/></xsl:otherwise>
  </xsl:choose>
</xsl:template>

<!-- This must be called in the context of the result set element. -->
<!-- It inserts the title to be used for the resultSet choosing first -->
<!-- the value of the title attribute, and if that is not present defaulting -->
<!-- to the string Results. -->
<xsl:template name="resultSetTitle">
  <xsl:choose>
    <xsl:when test="@title"><xsl:value-of select="@title"/></xsl:when>
    <xsl:otherwise>Results</xsl:otherwise>
  </xsl:choose>
</xsl:template>

</xsl:stylesheet>