<?xml version="1.0"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "html"/>

<xsl:template match="/">
    <xsl:apply-templates select="webservice" />
</xsl:template>

<xsl:template match="webservice">
package <xsl:value-of select="packageName" />;

import java.math.BigDecimal;
import java.util.*;
import javax.naming.*;
import javax.xml.rpc.holders.*;
import javax.rmi.PortableRemoteObject;

import org.apache.axis.description.*;

import java.util.logging.Logger;
import java.util.logging.Level;
import com.lombardisoftware.logger.WLELoggerConstants;

import com.lombardisoftware.client.persistence.common.ID;
import com.lombardisoftware.client.persistence.common.BasedReference;
import com.lombardisoftware.client.persistence.common.Reference;
import com.lombardisoftware.client.persistence.common.versioning.VersioningContext;
import com.lombardisoftware.component.common.workflow.EJBWorkflowManagerDelegate;
import com.lombardisoftware.component.common.workflow.EJBWorkflowManagerDelegateFactory;
import com.lombardisoftware.component.common.workflow.EJBWorkflowManagerResult;
import com.lombardisoftware.core.config.TWConfiguration;
import com.lombardisoftware.core.UserInfo;
import com.lombardisoftware.core.TWStandardVariables;
import com.lombardisoftware.core.TWConstants;
import com.lombardisoftware.core.ExceptionHandler;
import com.lombardisoftware.server.eai.soap.WebServiceHelper;
import com.lombardisoftware.server.eai.soap.WebServiceHelperContext;
import com.lombardisoftware.core.TWObject;
import com.lombardisoftware.core.script.js.objects.TWDateSCR;

/**
 * Lombardi Software - TeamWorks
 *
 * This is an auto-generated class and it is used
 * in TeamWorks during the processing of a SOAP call.
 *
 * This class is generated for <xsl:value-of select="name" /> Web Service version <xsl:value-of select="versionId" />
 */

public class <xsl:value-of select="className" /> {
    private static final Logger logger = Logger.getLogger(WLELoggerConstants.INBND_WS_LOGGER, WLELoggerConstants.WLE_PIIMESSAGE_FILE);
    private static final String CLASS_NAME = "GenWebService";
	
	private VersioningContext __teamworks_autogen_versioning_context;
<xsl:apply-templates select="operation" />

<xsl:apply-templates select="twClass" />
<xsl:apply-templates select="twClassHolder" />
}
</xsl:template>

<xsl:template match="operation">
    <xsl:variable name="varIsProtected">
	<xsl:choose>
	<xsl:when test="../isProtected = 'false'">false</xsl:when>
	<xsl:otherwise>true</xsl:otherwise>
	</xsl:choose>
    </xsl:variable>
    public void <xsl:value-of select="name" />(<xsl:if test="$varIsProtected = 'true'">String username, String password<xsl:if test="inputParameter or outputParameter">, </xsl:if></xsl:if>
                                               <xsl:call-template name="writeFunctionParams" />)
    throws Throwable {
    	String METHOD_NAME ="<xsl:value-of select="name" />";
        if (logger.isLoggable(Level.FINE)) {
        	logger.logp(Level.FINE, CLASS_NAME, METHOD_NAME, "BEGIN: <xsl:value-of select="name" />() " <xsl:apply-templates select="inputParameter | inOutParam" mode="debug" />);
        }

        final HashMap __teamworks_autogen_variable_params = new HashMap();
        __teamworks_autogen_versioning_context = VersioningContext.fromExternalString("<xsl:value-of select="../versioningContext" />");
	    
        try {
            <xsl:choose>
        <xsl:when test="$varIsProtected = 'false'">
            WebServiceHelper.runAsWebserviceUser(new WebServiceHelper.WebServiceExecutor() {
        </xsl:when>
            <xsl:otherwise>
            WebServiceHelper.runAsWebserviceUser(username, password, new WebServiceHelper.WebServiceExecutor() {
            </xsl:otherwise>
            </xsl:choose>
                public void run(UserInfo __teamworks_autogen_variable_userInfo) throws Exception {
                    String METHOD_NAME = "run";
                    __teamworks_autogen_variable_params.put(TWStandardVariables.USER_ID, String.valueOf(ID.getBigDecimal(__teamworks_autogen_variable_userInfo.getUserId())));
                    __teamworks_autogen_variable_params.put(TWStandardVariables.USER_NAME, __teamworks_autogen_variable_userInfo.getUsername());
                    __teamworks_autogen_variable_params.put(TWStandardVariables.USER_FULLNAME, __teamworks_autogen_variable_userInfo.getFullname());


                    WebServiceHelperContext __teamworks_autogen_variable_input_context = WebServiceHelper.createContext();

<xsl:apply-templates select="inputParameter" mode="addToHashMap" />
<xsl:apply-templates select="inputParameter" mode="validate" />
<xsl:apply-templates select="inOutParam" mode="addToHashMap" />
<xsl:apply-templates select="inOutParam" mode="validate" />

                    if (logger.isLoggable(Level.INFO)) {
                    	logger.log(Level.INFO, "START_PROCESS", new Object[]{ "<xsl:value-of select="processName" />", __teamworks_autogen_variable_params} );
                    }

					BasedReference __teamworks_autogen_process_ref = BasedReference.get(__teamworks_autogen_versioning_context, Reference.fromExternalString("<xsl:value-of select="processRefFromRoot" />"));
                    EJBWorkflowManagerResult __teamworks_autogen_variable_workflowManagerResult;
                    
                    EJBWorkflowManagerDelegate __teamworks_autogen_variable_workflowManager = EJBWorkflowManagerDelegateFactory.getInstance().newInstance(__teamworks_autogen_versioning_context, __teamworks_autogen_process_ref);
                    try {
                        __teamworks_autogen_variable_workflowManagerResult = __teamworks_autogen_variable_workflowManager.resumeProcess(null, __teamworks_autogen_variable_params, null, false);
                    } finally {
                        __teamworks_autogen_variable_workflowManager.cleanup();
                    }
                    if (logger.isLoggable(Level.FINE)) {
                		logger.logp(Level.FINE, CLASS_NAME, METHOD_NAME, "END: workflowManagerResult = " + __teamworks_autogen_variable_workflowManagerResult);
                    }

                    HashMap __teamworks_autogen_variable_outputParameters = (HashMap) __teamworks_autogen_variable_workflowManagerResult.getData();
                    
                    // WLE-4022: need to activate the outputs since they have crossed a serialization boundary
                    TWObject.setActivationVersioningContext(__teamworks_autogen_versioning_context, Reference.resolve(__teamworks_autogen_versioning_context, __teamworks_autogen_process_ref.getDependencyPath()), __teamworks_autogen_variable_outputParameters, true);
                    
                    if (logger.isLoggable(Level.INFO)) {
                    	logger.log(Level.INFO, "FINISHED_PROCESS", new Object[] {"<xsl:value-of select="processName" />", __teamworks_autogen_variable_outputParameters});
                    }

                    List __teamworks_autogen_variable_iterator_list;

                    WebServiceHelperContext __teamworks_autogen_variable_output_context = WebServiceHelper.createContext();
<xsl:apply-templates select="outputParameter" mode="assignValuesFromSymbolTable" />

                }
            });

            if (logger.isLoggable(Level.FINE)) {
                logger.logp(Level.FINE, CLASS_NAME, METHOD_NAME, "END: <xsl:value-of select="name" />() " <xsl:apply-templates select="outputParameter" mode="debug" />);
            }
        } catch (Throwable e) {
            logger.log(Level.SEVERE, "WEBSERVICES_EXCEPTION", e);
            throw ExceptionHandler.findLowestThrowable(e);
        }
    }
</xsl:template>

<xsl:template match="inOutParam | inputParameter | outputParameter" mode="debug"> + "<xsl:if test="position() > 1">, </xsl:if><xsl:value-of select="name" /> = " + <xsl:value-of select="name" />
</xsl:template>

<xsl:template name="writeFunctionParams">
<xsl:apply-templates select="inputParameter" mode="funtionInputParams" />
<xsl:if test="inputParameter and outputParameter">, </xsl:if>
<xsl:apply-templates select="outputParameter" mode="funtionOutputParams" />
</xsl:template>

<xsl:template match="inputParameter" mode="funtionInputParams">
<xsl:if test="position() > 1">, </xsl:if>final <xsl:value-of select="className" /><xsl:text> </xsl:text><xsl:value-of select="name" />
</xsl:template>

<xsl:template match="outputParameter" mode="funtionOutputParams">
<xsl:if test="position() > 1">, </xsl:if>final <xsl:value-of select="className" /><xsl:text> </xsl:text><xsl:value-of select="name" />
</xsl:template>

<xsl:template match="outputParameter" mode="assignValuesFromSymbolTable">
<xsl:text>            </xsl:text><xsl:value-of select="name" />.value = (<xsl:value-of select="holderValueJavaClass" />) WebServiceHelper.scriptableValueToJava(__teamworks_autogen_variable_outputParameters.get("<xsl:value-of select="name" />"), <xsl:value-of select="holderValueJavaClass" />.class, __teamworks_autogen_variable_output_context);
</xsl:template>

<xsl:template match="inputParameter" mode="addToHashMap">
<xsl:text>                </xsl:text>__teamworks_autogen_variable_params.put(TWConstants.NAMESPACE_LOCAL_PREFIX + "<xsl:value-of select="name" />", WebServiceHelper.toScriptableObjectValue(__teamworks_autogen_versioning_context, <xsl:value-of select="name" />, Reference.fromExternalString("<xsl:value-of select="classRef" />"), __teamworks_autogen_variable_input_context));
</xsl:template>

<xsl:template match="inOutParam" mode="addToHashMap">
<xsl:text>            </xsl:text>if (<xsl:value-of select="name" /> != null <xsl:text disable-output-escaping="yes">&amp;&amp; </xsl:text> <xsl:value-of select="name" />.value != null) {
<xsl:text>                </xsl:text>__teamworks_autogen_variable_params.put(TWConstants.NAMESPACE_LOCAL_PREFIX + "<xsl:value-of select="name" />", WebServiceHelper.toScriptableObjectValue(__teamworks_autogen_versioning_context, <xsl:value-of select="name" />.value, Reference.fromExternalString("<xsl:value-of select="classRef" />"), __teamworks_autogen_variable_input_context));
<xsl:text>            </xsl:text>}
</xsl:template>

<xsl:template match="inputParameter" mode="validate">
<xsl:text>            </xsl:text>WebServiceHelper.validate(__teamworks_autogen_versioning_context, __teamworks_autogen_variable_params.get("<xsl:value-of select="name" />"), Reference.fromExternalString("<xsl:value-of select="classRef" />"), <xsl:value-of select="isArrayOf" />);
</xsl:template>

<xsl:template match="inOutParam" mode="validate">
<xsl:text>            </xsl:text>WebServiceHelper.validate(__teamworks_autogen_versioning_context, __teamworks_autogen_variable_params.get("<xsl:value-of select="name" />"), Reference.fromExternalString("<xsl:value-of select="classRef" />"), <xsl:value-of select="isArrayOf" />);
</xsl:template>

<xsl:template match="twClassHolder[@isRootLevelArray = 'true']">
    public static class <xsl:value-of select="@name" /> implements javax.xml.rpc.holders.Holder {
            public <xsl:value-of select="@holderValueJavaClass" /> value;

            public <xsl:value-of select="@name" />() {
            }

            public <xsl:value-of select="@name" />(<xsl:value-of select="@holderValueJavaClass" /> value) {
                    this.value = value;
            }

            public String toString() {
                return (value == null) ? "null" : value.toString();
            }

            public void assignArrayValue(<xsl:value-of select="@twClass" />[] array) {
                value = new <xsl:value-of select="@holderValueJavaClass" />();
                value.item = array;
            }
    }

</xsl:template>

<xsl:template match="twClassHolder">
    public static class <xsl:value-of select="@name" /> implements javax.xml.rpc.holders.Holder {
            public <xsl:value-of select="@holderValueJavaClass" /> value;

            public <xsl:value-of select="@name" />() {
            }

            public <xsl:value-of select="@name" />(<xsl:value-of select="@holderValueJavaClass" /> value) {
                    this.value = value;
            }

            public String toString() {
                return (value == null) ? "null" : value.toString();
            }
    }

</xsl:template>

<xsl:template match="twClass">
    public static class <xsl:value-of select="name" /> implements com.lombardisoftware.server.eai.soap.WebServiceComplexType<xsl:if test="isArrayWrapper = 'true'">, com.lombardisoftware.server.eai.soap.array.WSArrayWrapper </xsl:if> {
<xsl:apply-templates select="property" mode="declareField" />

        public <xsl:value-of select="name" />() {
        }

        public TWObject toSTObjectScriptable(VersioningContext vContext, WebServiceHelperContext context) {
            <xsl:choose>
                <xsl:when test="isArrayWrapper = 'true'">
                    return (TWObject) WebServiceHelper.toScriptableObjectValue(vContext, <xsl:value-of select="property/name" />, Reference.fromExternalString("<xsl:value-of select="property/classRef" />"), context);
                </xsl:when>
                <xsl:otherwise>
            TWObject jsObject = WebServiceHelper.createComplexObject(vContext, Reference.fromExternalString("<xsl:value-of select="classRef" />"));
<xsl:apply-templates select="property" mode="toTWObject" />

            return jsObject;
                </xsl:otherwise>
             </xsl:choose>
        }

        public static <xsl:value-of select="name" /> valueOf(TWObject jsObject, WebServiceHelperContext context) {
            <xsl:choose>
                <xsl:when test="isArrayWrapper = 'true'">
                    <xsl:value-of select="name" /> data = new <xsl:value-of select="name" />();
                    context.registerMapping(jsObject, data);
                    data.<xsl:value-of select="property/name" /> = (<xsl:value-of select="property/javaClass" />) WebServiceHelper.scriptableArrayToJavaArrayWrapperValue(jsObject, <xsl:value-of select="property/javaClass" />.class, context);
                </xsl:when>
                <xsl:otherwise>
            <xsl:value-of select="name" /> data = new <xsl:value-of select="name" />();
            context.registerMapping(jsObject, data);
<xsl:apply-templates select="property" mode="valueOf" />
                </xsl:otherwise>
             </xsl:choose>

            return data;
        }

        <xsl:if test="isArrayWrapper = 'true'">
            public Object[] retrieveArray() {
                return <xsl:value-of select="property/name" />;
            }
        </xsl:if>
    }

</xsl:template>

<xsl:template match="property" mode="declareField">
<xsl:text>        </xsl:text>public <xsl:value-of select="javaClass" /><xsl:text> </xsl:text><xsl:value-of select="name" />;
</xsl:template>

<xsl:template match="property" mode="toTWObject">
<xsl:text>            </xsl:text>jsObject.setPropertyValue("<xsl:value-of select="name" />", WebServiceHelper.toScriptableObjectValue(vContext, <xsl:value-of select="name" />, Reference.fromExternalString("<xsl:value-of select="classRef" />"), context));
</xsl:template>

<xsl:template match="property" mode="valueOf">
<xsl:text>            </xsl:text>data.<xsl:value-of select="name" /> = (<xsl:value-of select="javaClass" />) WebServiceHelper.scriptableValueToJava(jsObject.getPropertyValue("<xsl:value-of select="name" />"), <xsl:value-of select="javaClass" />.class, context);
</xsl:template>

<xsl:template name="showFirstLetterUpperCase">
<xsl:param name="theString" />
<xsl:value-of select="translate(substring($theString, 1,1), 'abcdefghijklmnopqrtsuvwxyz', 'ABCDEFGHIJKLMNOPQRTSUVWXYZ')" /><xsl:value-of select="substring($theString, 2)" />
</xsl:template>

</xsl:stylesheet>
