<?xml version="1.0"?>

<!--    XSLT stylesheet to convert the Fop documentation collected in one xml file into a fo file
        for use in FOP 

TBD: - The faq doesn't show in the content
     - check why margin-bottom on the page with properties is too large
     - check why keep-next not only doesn't work, but leads to repeating already printed lines
     - make lines containing only code look nicer (smaller line height)
     - replace bullets in ordered lists with numbers
     - correct the hack replacing nbsp with '-'
     - handle the links correctly which have been external in the html doc and are now internal

-->

<xsl:stylesheet
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
     xmlns:fo="http://www.w3.org/1999/XSL/Format"
>

<xsl:template match ="/">
	<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

		<!-- defines page layout -->
		<fo:layout-master-set>

			<fo:simple-page-master master-name="simple"
										page-height="29.7cm" 
										page-width="21cm"
										margin-top="1.5cm" 
										margin-bottom="2cm" 
										margin-left="2.5cm" 
										margin-right="2.5cm">
				<fo:region-body margin-top="3cm"/>
				<fo:region-before extent="1.5cm"/>
				<fo:region-after extent="1.5cm"/>
			</fo:simple-page-master>
		</fo:layout-master-set>

		<fo:page-sequence master-name="simple">
			<fo:static-content flow-name="xsl-region-before">
				<fo:block text-align="end" font-size="10pt" font-family="serif" line-height="14pt" >
					p. <fo:page-number/>
				</fo:block>
			</fo:static-content> 

			<fo:flow flow-name="xsl-region-body">
				<xsl:apply-templates /> 
			</fo:flow>
		</fo:page-sequence>
	</fo:root>
</xsl:template>

<!-- s1 -->
<xsl:template match ="s1">
   <fo:block font-size="18pt" line-height="24pt" text-align="center"  space-before.optimum="15pt" space-after.optimum="15pt">
     <xsl:value-of select="@title"/>
   </fo:block>

    <xsl:apply-templates/> 
</xsl:template>


<xsl:template match ="p"> 
   <fo:block font-size="11pt" line-height="13pt" text-align="justify" space-before.optimum="15pt" space-after.optimum="15pt">
     <xsl:apply-templates/> 
   </fo:block>
</xsl:template>


<xsl:template match ="a">
   <fo:basic-link color="blue" external-destination="{@href}">
     <xsl:apply-templates/> 
   </fo:basic-link>
</xsl:template>

</xsl:stylesheet>
